unit uDanglingElse1;

{ **************************************************************************** }
{ **************************************************************************** }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    PnlUeberschrift: TPanel;
    LblUeberschrift: TLabel;
    MemAusgangslage: TMemo;
    BvlM1: TBevel;
    LblM1: TLabel;
    BvlM2: TBevel;
    LblM2: TLabel;
    MemM1: TMemo;
    MemM2: TMemo;
    RadGrpSchuelerDoof: TRadioGroup;
    RadGrpLehrerDoof: TRadioGroup;
    LblM1Korrekt: TLabel;
    LblM2Falsch: TLabel;
    BitBtnAuswertenM1: TBitBtn;
    BitBtnAuswertenM2: TBitBtn;
    EdtAuswertenM1: TEdit;
    EdtAuswertenM2: TEdit;
    BvlAuswerten: TBevel;
    ImgM1Korrekt: TImage;
    ImgM2Falsch: TImage;
    LblTest: TLabel;
    BitBtnInformation: TBitBtn;
    BitBtnSchliessen: TBitBtn;
    BitBtnAufloesen: TBitBtn;
    BvlSteuerung: TBevel;
    LblFrage: TLabel;
    procedure BitBtnAuswertenM1Click(Sender: TObject);
    procedure BitBtnAuswertenM2Click(Sender: TObject);
    procedure RadGrpSchuelerDoofClick(Sender: TObject);
    procedure BitBtnInformationClick(Sender: TObject);
    procedure BitBtnSchliessenClick(Sender: TObject);
    procedure BitBtnAufloesenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

{ **************************************************************************** }
{ **************************************************************************** }

implementation

{$R *.dfm}

procedure TForm1.RadGrpSchuelerDoofClick(Sender: TObject);
begin
  { Reinitialisierung }
  EdtAuswertenM1.Text := '';
  EdtAuswertenM2.Text := '';
end;

{ **************************************************************************** }

procedure TForm1.BitBtnAuswertenM1Click(Sender: TObject);
var
  SchuelerDoof,LehrerDoof: Boolean;
begin
  { Initialisierung }
  if RadGrpSchuelerDoof.ItemIndex = 0 then SchuelerDoof := True
  else SchuelerDoof := False;
  if RadGrpLehrerDoof.ItemIndex = 0 then LehrerDoof := True
  else LehrerDoof := False;

  { Berechnung }
  if SchuelerDoof then
    if LehrerDoof then EdtAuswertenM1.Text := 'Ganzer Kurs doof.'
    else EdtAuswertenM1.Text := 'Nur Schler doof.';
end;

{ **************************************************************************** }

procedure TForm1.BitBtnAuswertenM2Click(Sender: TObject);
var
  SchuelerDoof,LehrerDoof: Boolean;
begin
  { Initialisierung }
  if RadGrpSchuelerDoof.ItemIndex = 0 then SchuelerDoof := True
  else SchuelerDoof := False;
  if RadGrpLehrerDoof.ItemIndex = 0 then LehrerDoof := True
  else LehrerDoof := False;

  { Berechnung }
  if SchuelerDoof then
    if LehrerDoof then EdtAuswertenM2.Text := 'Ganzer Kurs doof.'
  else EdtAuswertenM2.Text := 'Keiner doof.';
end;

{ **************************************************************************** }

procedure TForm1.BitBtnAufloesenClick(Sender: TObject);
begin
  { Sichtbarmachen der Aufloesung }
  LblM1Korrekt.Visible := True;
  ImgM1Korrekt.Visible := True;
  LblM2Falsch.Visible := True;
  ImgM2Falsch.Visible := True;

  (*
  { BitBtnAufloesen sperren }
  BitBtnAufloesen.Enabled := False;
  *)

  MessageDlg('Mglichkeit 1 stimmt: Der Else-Zweig wird auf die letzte If-Abfrage bezogen.' + #13 + #13 +
    'Mchte man, dass sich der Else-Zweig auf die uere If-Anweisung bezieht, muss diese mit begin/end geklammert werden.' + #13 + #13 +
    'Das Dangling-Else-Problem (das letztlich kein Problem darstellt, da es genau definiert ist), ist ein eindrucksvolles Beispiel dafr,' + #13 +
    'wie durch fehlerhafte bzw. nicht vorgenommene Quellcodeeinrckung Verwirrung und Missverstndnisse entstehen knnen.' + #13 + #13 +
    'Weitere Informationen siehe online unter http://de.wikipedia.org/wiki/Dangling_else.',mtInformation,[mbOK],0);
end;

{ **************************************************************************** }

procedure TForm1.BitBtnInformationClick(Sender: TObject);
begin
  MessageDlg('Dangling-Else-Problem (V1.2)' + #13 +
    'Demonstrationsprogramm zur Darlegung des "Dangling else"-' + #13 + 'Mehrdeutigkeitsproblems in der Programmierung.'
    + #13 + #13 +
    'M. Zirbes, 2023' + #13 + #13 +
    'Bei diesem Programm handelt es sich um Freeware,' + #13 +
    'd.h. es steht zur kostenlosen Nutzung frei zur Verfgung' + #13 +
    'und darf ohne Entgelt vervielfltigt und verbreitet werden.' + #13 + #13 +
    'Kontakt: schule@mijozi.de',mtInformation,[mbOK],0);
end;

{ **************************************************************************** }

procedure TForm1.BitBtnSchliessenClick(Sender: TObject);
begin
  Close;
end;

{ **************************************************************************** }
{ **************************************************************************** }

end.
